﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OOP2
{
    public abstract class Shape
    {
        private double x = 0.0;
        private double y = 0.0;

        public Shape(double x, double y)
        {
            this.x = x;
            this.y = y;
        }

        public double getX()
        {
            return x;
        }

        public double getY()
        {
            return y;
        }

        public abstract double getVolume();
    }

    public class Square : Shape, Boundary
    {
        private double side = 0.0;

        public Square(double x, double y, double side) : base(x, y)
        {
            this.side = side;
        }

        // We must include getVolume and it must be marked with override keyword
        public override double getVolume()
        {
            return side * side;
        }

        public double getCircumference()
        {
            return side * 4.0;
        }

    }

    public interface Boundary
    {
        double getCircumference();
    }

    class OOP2
    {
        static void Main(string[] args)
        {
        }
    }
}
